Index: /protocol/src/test/java/geniusweb/protocol/session/ConnectionWithPartiesTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/ConnectionWithPartiesTest.java	(revision 8)
+++ /protocol/src/test/java/geniusweb/protocol/session/ConnectionWithPartiesTest.java	(revision 9)
@@ -14,29 +14,29 @@
 
 import geniusweb.actions.PartyId;
-import geniusweb.protocol.partyconnection.ConnectionWithParties;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import tudelft.utilities.junit.GeneralTests;
 
 public class ConnectionWithPartiesTest
-		extends GeneralTests<ConnectionWithParties> {
+		extends GeneralTests<ProtocolToPartyConnections> {
 	PartyId party1 = new PartyId("party1");
 	PartyId party2 = new PartyId("party2");
 	PartyId party3 = new PartyId("party3");
 
-	private ConnectionWithParty con1 = mock(ConnectionWithParty.class);
-	private ConnectionWithParty con2 = mock(ConnectionWithParty.class);
-	private ConnectionWithParty con3 = mock(ConnectionWithParty.class);
+	private ProtocolToPartyConn con1 = mock(ProtocolToPartyConn.class);
+	private ProtocolToPartyConn con2 = mock(ProtocolToPartyConn.class);
+	private ProtocolToPartyConn con3 = mock(ProtocolToPartyConn.class);
 
-	private ConnectionWithParties conns1 = new ConnectionWithParties(
+	private ProtocolToPartyConnections conns1 = new ProtocolToPartyConnections(
 			Arrays.asList(con1, con2));
-	private ConnectionWithParties conns1a = new ConnectionWithParties(
+	private ProtocolToPartyConnections conns1a = new ProtocolToPartyConnections(
 			Arrays.asList(con1, con2));
-	private ConnectionWithParties conns2 = new ConnectionWithParties(
+	private ProtocolToPartyConnections conns2 = new ProtocolToPartyConnections(
 			Arrays.asList(con1, con3));
-	private ConnectionWithParties conns3 = new ConnectionWithParties(
+	private ProtocolToPartyConnections conns3 = new ProtocolToPartyConnections(
 			Arrays.asList(con2, con1));
-	private ConnectionWithParties conns4 = new ConnectionWithParties(
+	private ProtocolToPartyConnections conns4 = new ProtocolToPartyConnections(
 			Arrays.asList(con2, con1, con3));
-	private ConnectionWithParties conns5 = new ConnectionWithParties(
+	private ProtocolToPartyConnections conns5 = new ProtocolToPartyConnections(
 			Arrays.asList(con2, con1, con3, con1));
 
@@ -54,5 +54,5 @@
 
 	@Override
-	public List<List<ConnectionWithParties>> getGeneralTestData() {
+	public List<List<ProtocolToPartyConnections>> getGeneralTestData() {
 		return Arrays.asList(Arrays.asList(conns1, conns1a),
 				Arrays.asList(conns2), Arrays.asList(conns3),
@@ -98,5 +98,5 @@
 	@Test
 	public void withPartyTest() {
-		ConnectionWithParties conns = conns3.with(con3);
+		ProtocolToPartyConnections conns = conns3.with(con3);
 		assertEquals(2, conns3.size());
 		assertEquals(3, conns.size());
Index: /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 8)
+++ /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 9)
@@ -27,5 +27,5 @@
 import geniusweb.progress.ProgressTime;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithParties;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.session.saop.SAOPSettings;
 import geniusweb.references.Parameters;
@@ -48,5 +48,5 @@
 		PartyId party1 = new PartyId("party1");
 		actions.add(new EndNegotiation(party1));
-		ConnectionWithParties conns = new ConnectionWithParties(
+		ProtocolToPartyConnections conns = new ProtocolToPartyConnections(
 				Collections.EMPTY_LIST);
 		DeadlineTime deadline = new DeadlineTime(1000);
@@ -126,5 +126,5 @@
 
 	public DefaultSessionState1(List<Action> actions,
-			ConnectionWithParties conns, Progress progr,
+			ProtocolToPartyConnections conns, Progress progr,
 			SessionSettings settings,
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 8)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 9)
@@ -27,6 +27,6 @@
 import geniusweb.progress.ProgressTime;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithParties;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.session.SessionSettings;
 import tudelft.utilities.junit.GeneralTests;
@@ -42,13 +42,13 @@
 	private List<Action> actions2 = Arrays.asList(action);
 
-	private ConnectionWithParty party1conn = mock(ConnectionWithParty.class);
-	private ConnectionWithParty party2conn = mock(ConnectionWithParty.class);
-	private ConnectionWithParty party3conn = mock(ConnectionWithParty.class);
-
-	private ConnectionWithParties connections = new ConnectionWithParties(
+	private ProtocolToPartyConn party1conn = mock(ProtocolToPartyConn.class);
+	private ProtocolToPartyConn party2conn = mock(ProtocolToPartyConn.class);
+	private ProtocolToPartyConn party3conn = mock(ProtocolToPartyConn.class);
+
+	private ProtocolToPartyConnections connections = new ProtocolToPartyConnections(
 			Arrays.asList(party1conn, party2conn));
-	private ConnectionWithParties connections2 = new ConnectionWithParties(
+	private ProtocolToPartyConnections connections2 = new ProtocolToPartyConnections(
 			Arrays.asList(party1conn, party3conn));
-	private ConnectionWithParties connections3 = new ConnectionWithParties(
+	private ProtocolToPartyConnections connections3 = new ProtocolToPartyConnections(
 			Arrays.asList(party1conn, party2conn, party3conn));
 
@@ -114,5 +114,5 @@
 	@Test
 	public void constructWith0Connection() {
-		new SAOPState(actions, new ConnectionWithParties(Arrays.asList()),
+		new SAOPState(actions, new ProtocolToPartyConnections(Arrays.asList()),
 				progresstime, settings, null, null);
 	}
@@ -132,5 +132,5 @@
 	@Test
 	public void testNextActor2() {
-		ConnectionWithParties conns = new ConnectionWithParties(
+		ProtocolToPartyConnections conns = new ProtocolToPartyConnections(
 				Arrays.asList(party2conn, party3conn));
 		SAOPState state = new SAOPState(actions, conns, progresstime, settings,
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 8)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 9)
@@ -39,7 +39,7 @@
 import geniusweb.progress.Progress;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithParties;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.references.Parameters;
 import geniusweb.references.PartyRef;
@@ -76,14 +76,14 @@
 	private final PartyWithProfile party2 = mock(PartyWithProfile.class);
 	private SAOP saop;
-	private ConnectionWithPartyFactory factory;
+	private ProtocolToPartyConnFactory factory;
 	private List connections;
-	private ConnectionWithParty conn1 = mock(ConnectionWithParty.class),
-			conn2 = mock(ConnectionWithParty.class);
+	private ProtocolToPartyConn conn1 = mock(ProtocolToPartyConn.class),
+			conn2 = mock(ProtocolToPartyConn.class);
 	private Map<PartyId, PartyWithProfile> partyprofiles;
 	private Progress progress = mock(Progress.class);
 	private ProfileRef profile1;
 	private ProfileRef profile2;
-	private ConnectionWithParties connectionswithparties = mock(
-			ConnectionWithParties.class);;
+	private ProtocolToPartyConnections connectionswithparties = mock(
+			ProtocolToPartyConnections.class);;
 	@SuppressWarnings("unchecked")
 	private final Listener<ProtocolEvent> testlistener = mock(Listener.class);
@@ -116,5 +116,5 @@
 		when(settings.getDeadline()).thenReturn(deadlinetime);
 
-		factory = mock(ConnectionWithPartyFactory.class);
+		factory = mock(ProtocolToPartyConnFactory.class);
 		connections = mock(List.class);
 		when(factory.connect(any(List.class))).thenReturn(connections);
@@ -159,5 +159,5 @@
 		when(state.getPartyProfiles()).thenReturn(partyprofiles);
 		when(state.getProgress()).thenReturn(progress);
-		when(state.with(any(ConnectionWithParty.class),
+		when(state.with(any(ProtocolToPartyConn.class),
 				any(PartyWithProfile.class))).thenReturn(connectedstate);
 		when(state.getNextActor()).thenReturn(PARTY1ID);
Index: /protocol/src/test/java/geniusweb/protocol/tournament/AllPermutationsProtocolTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/tournament/AllPermutationsProtocolTest.java	(revision 8)
+++ /protocol/src/test/java/geniusweb/protocol/tournament/AllPermutationsProtocolTest.java	(revision 9)
@@ -24,5 +24,5 @@
 import geniusweb.protocol.NegoState;
 import geniusweb.protocol.SessionResult;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -42,6 +42,6 @@
 	private final AllPermutationsProtocol app = new AllPermutationsProtocol(
 			state, log);
-	private final ConnectionWithPartyFactory factory = mock(
-			ConnectionWithPartyFactory.class);
+	private final ProtocolToPartyConnFactory factory = mock(
+			ProtocolToPartyConnFactory.class);
 	private final SessionSettings settings = mock(SessionSettings.class);
 	private final SessionState finalsessionstate = mock(SessionState.class);
@@ -140,5 +140,5 @@
 
 	@Override
-	public void start(ConnectionWithPartyFactory connectionfactory) {
+	public void start(ProtocolToPartyConnFactory connectionfactory) {
 
 	}
Index: /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java
===================================================================
--- /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java	(revision 8)
+++ /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java	(revision 9)
@@ -7,5 +7,5 @@
 
 import geniusweb.actions.Action;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
@@ -104,5 +104,5 @@
 
 	@Override
-	public void connect(Connection<Inform, Action> connection) {
+	public void connect(ConnectionEnd<Inform, Action> connection) {
 		pyparty.connect(connection);
 	}
Index: /references/src/main/java/geniusweb/connection/Connectable.java
===================================================================
--- /references/src/main/java/geniusweb/connection/Connectable.java	(revision 8)
+++ /references/src/main/java/geniusweb/connection/Connectable.java	(revision 9)
@@ -2,7 +2,8 @@
 
 /**
- * a socket for a general two-way connection
+ * A Connectable is an object that can connect on request with a provided
+ * {@link ConnectionEnd} and then respond to incoming and outgong signals.
  *
- * @param <INTYPE> the type of incoming messages
+ * @param <INTYPE>  the type of incoming messages
  * @param <OUTTYPE> the type of outgoing messages
  */
@@ -13,5 +14,5 @@
 	 * @param connection the new connection
 	 */
-	void connect(Connection<INTYPE, OUTTYPE> connection);
+	void connect(ConnectionEnd<INTYPE, OUTTYPE> connection);
 
 	/**
Index: /references/src/main/java/geniusweb/connection/ConnectionEnd.java
===================================================================
--- /references/src/main/java/geniusweb/connection/ConnectionEnd.java	(revision 9)
+++ /references/src/main/java/geniusweb/connection/ConnectionEnd.java	(revision 9)
@@ -0,0 +1,73 @@
+package geniusweb.connection;
+
+import java.io.IOException;
+import java.net.SocketException;
+import java.net.URI;
+
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.Listenable;
+
+/**
+ * One end of a general two-way connection. incoming data is reported through
+ * the {@link Listenable} channel, sending events of the INTYPE.
+ * <p>
+ * 
+ * The connection mechanism assumed here is fundamentally asymmetric. One side
+ * is "Connectable", the other side is a ConnectionEnd created (usually from a
+ * {@link Reference}. This matches the typical client-server system (web
+ * architecture).
+ * 
+ * <p>
+ * If an internal error occurs, eg a socket failure, timeout, or parser error, a
+ * null event is sent into the Listenable. {@link #getError()} can be called to
+ * find out about the error.
+ *
+ * @param <INTYPE>  the type of incoming messages (incoming for the user of this
+ *                  connection end). Incoming messages are received through
+ *                  Listener#not. Incoming messages are usually asynchronous.
+ * @param <OUTTYPE> the type of outgoing messages (outgoing for the user of this
+ *                  connection end). Outgoing messages can be sent directly with
+ *                  #send.
+ * 
+ */
+public interface ConnectionEnd<INTYPE, OUTTYPE> extends Listenable<INTYPE> {
+
+	/**
+	 * Send data out (and flush the output so that there are no excessive delays
+	 * in sending the data). This call is assumed to return immediately (never
+	 * block, eg on synchronized, Thread.sleep, IO, etc). When this is called
+	 * multiple times in sequence, the data should arrive at the receiver end in
+	 * the same order.
+	 * 
+	 * @param data the data to be sent.
+	 * @throws IOException if the data failed to be sent.
+	 */
+	void send(OUTTYPE data) throws IOException;
+
+	/**
+	 * @return Reference that was used to create this connection
+	 */
+	Reference getReference();
+
+	/**
+	 * @return the URI of the remote endpoint that makes up the connection. This
+	 *         is a URI that uniquely identifies the remote object
+	 */
+	URI getRemoteURI();
+
+	/**
+	 * Close the connection. Should return immediately (not block). Before
+	 * really closing, this should attempt to send out possibly cached messages
+	 * before closing the connection.
+	 * 
+	 */
+	void close();
+
+	/**
+	 * @return the latest internal error, or null if no error occured. If the
+	 *         channel is closed, this is set to {@link SocketException} "Socket
+	 *         closed", even if the close was a "normal" termination eg when
+	 *         {@link #close()} was called.
+	 */
+	Throwable getError();
+}
Index: /references/src/main/java/geniusweb/connection/ConnectionFactory.java
===================================================================
--- /references/src/main/java/geniusweb/connection/ConnectionFactory.java	(revision 8)
+++ /references/src/main/java/geniusweb/connection/ConnectionFactory.java	(revision 9)
@@ -9,4 +9,5 @@
  * factory that can turn a {@link Reference} into a connection to that
  * reference.
+ * 
  * 
  * @param <INTYPE>  the type of incoming messages. Incoming messages are
@@ -30,5 +31,5 @@
 	 *                                 the server. This suggest to retry later.
 	 */
-	Connection<INTYPE, OUTTYPE> connect(Reference reference)
+	ConnectionEnd<INTYPE, OUTTYPE> connect(Reference reference)
 			throws IOException, NoResourcesNowException;
 
Index: /references/src/main/java/geniusweb/connection/DefaultConnection.java
===================================================================
--- /references/src/main/java/geniusweb/connection/DefaultConnection.java	(revision 8)
+++ /references/src/main/java/geniusweb/connection/DefaultConnection.java	(revision 9)
@@ -14,4 +14,4 @@
  */
 public abstract class DefaultConnection<INTYPE, OUTTYPE> extends
-		DefaultListenable<INTYPE> implements Connection<INTYPE, OUTTYPE> {
+		DefaultListenable<INTYPE> implements ConnectionEnd<INTYPE, OUTTYPE> {
 }
Index: /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 8)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 9)
@@ -4,5 +4,5 @@
 import java.net.URI;
 
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.references.Reference;
 import tudelft.utilities.listener.DefaultListenable;
@@ -17,5 +17,5 @@
  */
 public class BasicConnection<IN, OUT> extends DefaultListenable<IN>
-		implements Connection<IN, OUT> {
+		implements ConnectionEnd<IN, OUT> {
 	private final Reference reference;
 	private final URI uri;
Index: /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 8)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 9)
@@ -13,6 +13,6 @@
 import geniusweb.party.Party;
 import geniusweb.party.inform.Inform;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.references.Reference;
 import tudelft.utilities.repository.NoResourcesNowException;
@@ -25,5 +25,5 @@
  *
  */
-public class ClassPathConnectionFactory implements ConnectionWithPartyFactory {
+public class ClassPathConnectionFactory implements ProtocolToPartyConnFactory {
 	private static final String SCHEME = "classpath";
 	private static int serialcounter = 1;
@@ -31,5 +31,5 @@
 
 	@Override
-	public ConnectionWithParty connect(Reference reference) {
+	public ProtocolToPartyConn connect(Reference reference) {
 		// set up the whole other party including the connection to it.
 		String classpath = getClassPath(reference.getURI());
@@ -42,6 +42,6 @@
 				uri("classpath:" + reference.getURI().getSchemeSpecificPart()
 						+ "." + (serialcounter++)));
-		party2protocol.init(action -> protocol2party.notifyChange(action));
-		protocol2party.init(info -> party2protocol.notifyChange(info));
+		party2protocol.init(action -> protocol2party.notifyListeners(action));
+		protocol2party.init(info -> party2protocol.notifyListeners(info));
 
 		party.connect(party2protocol);
@@ -102,7 +102,7 @@
 
 	@Override
-	public List<ConnectionWithParty> connect(List<Reference> references)
+	public List<ProtocolToPartyConn> connect(List<Reference> references)
 			throws IOException, NoResourcesNowException {
-		List<ConnectionWithParty> connections = new LinkedList<>();
+		List<ProtocolToPartyConn> connections = new LinkedList<>();
 		for (Reference partyref : references) {
 			connections.add(connect(partyref));
@@ -114,5 +114,5 @@
 
 class BasicConnectionWithParty extends BasicConnection<Action, Inform>
-		implements ConnectionWithParty {
+		implements ProtocolToPartyConn {
 
 	private PartyId id;
Index: /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 8)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 9)
@@ -13,5 +13,5 @@
 import geniusweb.protocol.NegoProtocol;
 import geniusweb.protocol.NegoSettings;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionSettings;
 import tudelft.utilities.logging.ReportToLogger;
@@ -27,10 +27,10 @@
 	private final NegoSettings settings;
 	private final NegoProtocol protocol;
-	private final ConnectionWithPartyFactory connectionfactory;
+	private final ProtocolToPartyConnFactory connectionfactory;
 	private final Reporter log;
 	private final static ObjectMapper jackson = new ObjectMapper();
 
 	public NegoRunner(NegoSettings settings,
-			ConnectionWithPartyFactory connectionfactory, Reporter logger) {
+			ProtocolToPartyConnFactory connectionfactory, Reporter logger) {
 		if (settings == null || connectionfactory == null) {
 			throw new NullPointerException("Arguments must be not null");
Index: /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java
===================================================================
--- /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 8)
+++ /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 9)
@@ -10,5 +10,5 @@
 
 import geniusweb.actions.Action;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.party.inform.Inform;
 import geniusweb.references.PartyRef;
@@ -42,5 +42,5 @@
 	@Test
 	public void testRandomParty() throws IOException, URISyntaxException {
-		Connection<Action, Inform> party = factory.connect(new PartyRef(
+		ConnectionEnd<Action, Inform> party = factory.connect(new PartyRef(
 				"classpath:geniusweb.exampleparties.randomparty.RandomParty"));
 		assertNotNull(party);
Index: /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java
===================================================================
--- /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java	(revision 8)
+++ /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java	(revision 9)
@@ -18,5 +18,5 @@
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -47,5 +47,5 @@
 	public void smokeTest() {
 		new NegoRunner(mock(SessionSettings.class),
-				mock(ConnectionWithPartyFactory.class), logger);
+				mock(ProtocolToPartyConnFactory.class), logger);
 	}
 
@@ -56,6 +56,6 @@
 		when(settings.getProtocol(logger)).thenReturn(protocol);
 		@SuppressWarnings("unchecked")
-		ConnectionWithPartyFactory factory = mock(
-				ConnectionWithPartyFactory.class);
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
 
 		NegoRunner runner = spy(
@@ -80,6 +80,6 @@
 		Reporter logger = mock(Reporter.class);
 		@SuppressWarnings("unchecked")
-		ConnectionWithPartyFactory factory = mock(
-				ConnectionWithPartyFactory.class);
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
 		NegoRunner runner = spy(
 				new NegoRunner(settings, factory, logger));
@@ -107,6 +107,6 @@
 		when(protocol.getState()).thenReturn(state);
 		@SuppressWarnings("unchecked")
-		ConnectionWithPartyFactory factory = mock(
-				ConnectionWithPartyFactory.class);
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
 		NegoRunner runner = spy(
 				new NegoRunner(settings, factory, logger));
